# abstract class Crystal::Macros::UnaryExpression

- Crystal::Macros::UnaryExpression
- Crystal::Macros::ASTNode

##
Overview

An unary expression

##
Direct Known Subclasses

- Crystal::Macros::AlignOf
- Crystal::Macros::DoubleSplat
- Crystal::Macros::InstanceAlignOf
- Crystal::Macros::InstanceSizeOf
- Crystal::Macros::MacroVerbatim
- Crystal::Macros::Not
- Crystal::Macros::Out
- Crystal::Macros::PointerOf
- Crystal::Macros::SizeOf
- Crystal::Macros::Splat

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #exp : ASTNode

  Returns the expression that this unary operation is applied to.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def exp : ASTNode #

Returns the expression that this unary operation is applied to.